************************************************************************
* File: lung2.for
************************************************************************
* Scopo: metodologia uso GOTO per simulare ciclo REPEAT-UNTIL del PASCAL
************************************************************************

      PROGRAM CalcolaLunghezza2
* Legge da tastiera una sequenza di interi, terminata da 0.
* Calcola la lunghezza della sequenza (senza lo 0) e la stampa.

      IMPLICIT NONE
      INTEGER lunghezza, dato

      DATA lunghezza/0/

      WRITE (*,*) 'Inserisci una sequenza di interi, terminata da 0'

***** REPEAT
 10     lunghezza = lunghezza + 1
        READ (*,*) dato
      IF (dato .NE. 0) GOTO 10
***** UNTIL (dato .EQ. 0)

      WRITE (*,*) 'La sequenza (senza lo 0 finale) e'' lunga ',
     $     lunghezza - 1
      STOP

      END
